VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIShellIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2018

Private Const CLSID_ShellIcon As String = ""
    
Private Const IID_IShellIcon As String = _
    "{000214E5-0000-0000-C000-000000000046}"
    
Dim m_initialized As Boolean
Dim m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_GetIconOf
End Enum

Public Function GetIconOf(ByVal pidl As Long, ByVal flags As Long) As Long

    Dim lRet As Long
    Dim lpIconIndex As Long
    Dim plpIconIndex As Long
    
    plpIconIndex = VarPtr(lpIconIndex)
    
    If x_OleInvoke(vtb_GetIconOf, pidl, flags, plpIconIndex) Then

        lRet = lpIconIndex

    End If
    
    GetIconOf = lRet

End Function

Public Sub RaiseError(Optional ByVal Raise As Boolean = True)
    
    m_Interface.RaiseErrors = Raise
    
End Sub

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True
    m_Interface.ifc = pInterface
    m_initialized = True
    
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface
    
End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As _
    Boolean
    
    Dim ret As Long
    
    If Not m_initialized Then
    
        InterfaceError m_Interface, ecd_OleInvoke
        
    Else
    
        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)
        
    End If
    
End Function

Private Sub x_RaiseError()

    With m_Interface
    
        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIShellIcon", .etx
            
        .ecd = 0
        .etx = ""
        
    End With
    
End Sub

