Attribute VB_Name = "modGetIconOf"
Option Explicit

Private Const S_OK As Long = &H0
Private Const GIL_FORSHELL As Long = &H2
Private Const MAX_PATH As Long = 260
Private Const IID_IShellIcon As String = "{000214E5-0000-0000-C000-000000000046}"

' **************** Shell32.dll ****************
Private Declare Function SHGetDesktopFolder Lib "shell32" ( _
                         ByRef ppshf As Long) As Long
                         
' **************** Ole32.dll ****************
Private Declare Sub CoTaskMemFree Lib "ole32" ( _
                    ByVal pv As Long)
                    
Public Function GetIconIndex(ByVal sPath As String) As Long

    Dim lRet As Long
    Dim lPIDL As Long
    Dim pIShellIcon As Long
    Dim pIShellFolder As Long
    Dim pIExtractIcon As Long
    
    ' IShellFolder des Desktop ermitteln
    If SHGetDesktopFolder(pIShellFolder) = S_OK Then
    
        ' IShellFolder initialisieren
        Dim IShellFolder As New clsIShellFolder
        Call IShellFolder.Initialize(pIShellFolder)
        
        ' PIDL von Ordner/Datei ermitteln
        lPIDL = IShellFolder.ParseDisplayName(sPath)
        
        ' ist eine PIDL vorhanden
        If lPIDL <> 0 Then
                
            ' IShellIcon-Interface vom IShellFolder erstellen
            pIShellIcon = IShellFolder.QueryInterface(IID_IShellIcon)
                
            ' ist ein IShellIcon-Interface vorhanden
            If pIShellIcon <> 0 Then
                
                ' IShellIcon initialisieren
                Dim IShellIcon As New clsIShellIcon
                Call IShellIcon.Initialize(pIShellIcon)
                    
                ' Iconindex zur SystemImageList ermitteln
                lRet = IShellIcon.GetIconOf(lPIDL, GIL_FORSHELL)
                    
                ' aufrumen
                Set IShellIcon = Nothing
                    
            End If
            
            ' aufrumen
            Call CoTaskMemFree(lPIDL)
            
        End If
        
        ' aufrumen
        Set IShellFolder = Nothing
        
    End If
    
    GetIconIndex = lRet
    
End Function

